#include<stdio.h>
#include<string.h>

/***************************************************************************
 * Program      : bin_w2html
 * Author       : Nicholas Clifton Barnard <nickb@pobox.com>
 * Date         : March 4, 2003
 * Description  : The C binary side of the w2html package
 * Arguments    : w2html file.doc header.html footer.html
 * Copyright    : Copyright (C) 2003 Nicholas Barnard  
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ****************************************************************************/

main(int argc, char *argv[])
{
	char temp[1024];
	char bufone[1024];
	char buftwo[1024];
	char outfile[256];
	int len;
	FILE *out;
	FILE *in;
	FILE *cmod;

	/* Start reading the file until the start of the body */
	while (1) {
		if (fgets(temp, 1000, stdin) == NULL) {
			break;
		}
		if (strncmp(temp, "<body", 4) == 0) {
			break;
		}
	}

	/* Take arg1 copy to outfile and change the extention from .doc to .html */
	strcpy(outfile, argv[1]);
	len = strlen(outfile);
	outfile[len - 3] = 'h';
	outfile[len - 2] = 't';
	outfile[len - 1] = 'm';
	outfile[len] = 'l';
	outfile[len + 1] = '\0';


	/* Open the file HTML file to write to */

	if ((out = fopen(outfile, "w")) == NULL) {
		return;
	}
	/* Open the Header file and write to output HTML file */

	if ((in = fopen(argv[2], "r")) == NULL) {
	  /* Couldn't open the header, use a generic version */
	  /* copy the file name and remove the new line and .html to use in 
	     the HTML title */
		strcpy(temp, outfile);
		temp[len - 4] = '\0';
		fprintf(out, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
		fprintf(out, "<html xmlns = \"http://www.w3.org/1999/xhtml\">\n");
		fprintf(out, "<head>\n");
		fprintf(out, "<meta http - equiv = \"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
		fprintf(out, "<title>%s</title>\n", temp);
		fprintf(out, "</head>\n");
		fprintf(out, "<body>\n");

	} else {
	  /* The header file exists write all of it to the HTML output */
		while (1) {
			if (fgets(temp, 1000, in) == NULL) {
				break;
			}
			fputs(temp, out);

		}
		fclose(in);
	}


	/* Find the end of the body of the incoming HTML file */

	/* Fill the buffers for the "three stroke method" */
	fgets(bufone, 1000, stdin);
	fgets(buftwo, 1000, stdin);

	while (1) {
	  /* Get a line to work with, if the end of the file, break */
		if (fgets(temp, 1000, stdin) == NULL) {
			break;
		}
		/* If the beginning of the line matches <address> we've found
                   The third line of the wvHtml footer, so just break */
		if (strncmp(temp, "<address>", 8) == 0) {
			break;
		}
		/* Output the oldest buffer and move the others up in line */
		fputs(bufone, out);
		strcpy(bufone, buftwo);
		strcpy(buftwo, temp);

	}

	/* Open the footer file and write it out to the output file */
	if ((in = fopen(argv[3], "r")) == NULL) {
	  /* Couldn't open the footer use a generic version instead */
		fprintf(out, "</body></html>");
	} else {
		while (1) {
		  /* The footer exists write all of it to hte HTML output */
			if (fgets(temp, 1000, in) == NULL) {
				break;
			}
			fputs(temp, out);

		}
		fclose(in);
	}



	fclose(out);

	/* Create the command line to make the file readable by all then run it */
	sprintf(bufone, "chmod a+r %s", outfile);
	cmod = popen(bufone, "r");
	pclose(cmod);

	return; /* fin */
}




